> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Upsert Price List Records

PUT https://api.bigcommerce.com/stores/{store_hash}/v3/pricelists/{price_list_id}/records
Content-Type: application/json

Creates or updates *Price List Records*. 

**Required Fields**
* currency

**Notes**
* Batch requests support up to 1,000 items per request.
* Up to 2 concurrent batch upsert requests are supported with this API. Running more than the allowed concurrent requests in parallel on the **same store** will cause a `429` error, and your additional requests will fail. You are encouraged to run requests sequentially with as many records per request as possible to maximize performance.
* When updating a product with variants, or multiple SKUs, don't include records for the parent product SKU.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/management/price-lists/price-lists-records/upsert-price-list-records

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Products | modify | `store_v2_products` | | Products | read-only | `store_v2_products_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `price_list_id` (integer, required) — The ID of the `Price List` requested.
- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Headers

- `Accept` (string, required, default: application/json) — The [MIME type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of the response body.

### Body (application/json)

This endpoint expects a list of PricelistsPriceListIdRecordsPutRequestBodyContentApplicationJsonSchemaItems.

- `list of PricelistsPriceListIdRecordsPutRequestBodyContentApplicationJsonSchemaItems`

## Response

### 200

Success response for batch PUT requests of Price Records.

- `data` (PricelistsPriceListIdRecordsPutResponsesContentApplicationJsonSchemaData, optional)
- `meta` (PricelistsPriceListIdRecordsPutResponsesContentApplicationJsonSchemaMeta, optional)

## Errors

### 422 Unprocessable Entity Error

Error response for batch PUT of `Price Records`. May include errors during partial update in non-strict mode.

- `batch_errors` (list of PricelistsPriceListIdRecordsPutResponsesContentApplicationJsonSchemaBatchErrorsItems, optional)

### 429 Too Many Requests Error

Allowed number of requests exceeded.

- `status` (integer, optional) — The HTTP status code.
- `title` (string, optional) — The error title describing the particular error.
- `type` (string, optional)
- `instance` (string, optional)
- `errors` (ErrorResponseErrors, optional)

## Types

### PricelistsPriceListIdRecordsPutRequestBodyContentApplicationJsonSchemaItems

Price Record object used in batch create or update.

- `variant_id` (integer, optional) — The variant ID with which this price set is associated. Either `variant_id` or `sku` is required.
- `sku` (string, optional) — The SKU code associated with this `Price Record` if requested and it exists.
- `currency` (string, optional) — The 3-letter currency code with which this price set is associated.
- `price` (double, optional) — The list price for the variant mapped in a Price List. Overrides any existing or Catalog list price for the variant/product.
- `sale_price` (double, optional) — The sale price for the variant mapped in a Price List. Overrides any existing or Catalog sale price for the variant/product. If empty, the sale price will be treated as not being set on this variant.
- `retail_price` (double, optional) — The retail price for the variant mapped in a Price List. Overrides any existing or Catalog retail price for the variant/product. If empty, the retail price will be treated as not being set on this variant.
- `map_price` (double, optional) — The MAP (Minimum Advertised Price) for the variant mapped in a Price List. Overrides any existing or Catalog MAP price for the variant/product. If empty, the MAP price will be treated as not being set on this variant.
- `bulk_pricing_tiers` (list of PricelistsPriceListIdRecordsPutRequestBodyContentApplicationJsonSchemaItemsBulkPricingTiersItems, optional)

### PricelistsPriceListIdRecordsPutResponsesContentApplicationJsonSchemaData

### PricelistsPriceListIdRecordsPutResponsesContentApplicationJsonSchemaMeta

### PricelistsPriceListIdRecordsPutResponsesContentApplicationJsonSchemaBatchErrorsItems

Error during Price Record batch PUT request. Includes data sent in the request and errors.

- `data` (PricelistsPriceListIdRecordsPutResponsesContentApplicationJsonSchemaBatchErrorsItemsData, optional) — Price Record object used in batch create or update.
- `field_errors` (PricelistsPriceListIdRecordsPutResponsesContentApplicationJsonSchemaBatchErrorsItemsFieldErrors, optional)

### ErrorResponseErrors

### PricelistsPriceListIdRecordsPutRequestBodyContentApplicationJsonSchemaItemsBulkPricingTiersItems

- `quantity_min` (integer, optional) — The minimum quantity of associated variant in the cart needed to qualify for the pricing of this tier.
- `quantity_max` (integer, optional) — The maximum allowed quantity of associated variant in the cart to qualify for the pricing of this tier.
- `type` (enum, optional) — The type of adjustment that is made. Acceptable values: price – the adjustment amount per product; percent – the adjustment as a percentage of the original price; fixed – the adjusted absolute price of the product.
  - Allowed values: `fixed`, `price`, `percent`
- `amount` (double, optional) — The price adjustment amount. This value along with the type will decide the price per variant for the pricing tier.

### PricelistsPriceListIdRecordsPutResponsesContentApplicationJsonSchemaBatchErrorsItemsData

Price Record object used in batch create or update.

- `price_list_id` (integer, optional) — The Price List with which this price set is associated.
- `variant_id` (integer, optional) — The variant ID with which this price set is associated. Either `variant_id` or `sku` is required.
- `sku` (string, optional) — The variant with which this price set is associated. Either `sku` or `variant_id` is required.
- `currency` (string, optional) — The 3-letter currency code with which this price set is associated.

### PricelistsPriceListIdRecordsPutResponsesContentApplicationJsonSchemaBatchErrorsItemsFieldErrors

## Examples

**Request**

```json
[
  {}
]
```

**Response**

```json
{
  "data": {},
  "meta": {}
}
```

**SDK Code**

```python
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/pricelists/1/records"

payload = [{}]
headers = {
    "Accept": "application/json",
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/pricelists/1/records';
const options = {
  method: 'PUT',
  headers: {
    Accept: 'application/json',
    'X-Auth-Token': '<apiKey>',
    'Content-Type': 'application/json'
  },
  body: '[{}]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/pricelists/1/records"

	payload := strings.NewReader("[\n  {}\n]")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Accept", "application/json")
	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/pricelists/1/records")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Accept"] = 'application/json'
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {}\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.bigcommerce.com/stores/store_hash/v3/pricelists/1/records")
  .header("Accept", "application/json")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("[\n  {}\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.bigcommerce.com/stores/store_hash/v3/pricelists/1/records', [
  'body' => '[
  {}
]',
  'headers' => [
    'Accept' => 'application/json',
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/pricelists/1/records");
var request = new RestRequest(Method.PUT);
request.AddHeader("Accept", "application/json");
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {}\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Accept": "application/json",
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [[]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/pricelists/1/records")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```